LeetCode 37 Sudoku Solver (C,C++,Java,Python)

Problem:

Write a program to solve a Sudoku puzzle by filling the empty cells.

Empty cells are indicated by the character ‘.‘.

You may assume that there will be only one unique solution.

A sudoku puzzle...

...and its solution numbers marked in red.

Solution:

采用笨拙的DFS的办法,判断填入的数字是否合法,可以通过三个规则事先过滤掉不合法的数字,然后试试剩余的是否有合法的数字

题目大意:

填数独游戏。。。。。。

Java源代码(300ms):

public class Solution {
    public void solveSudoku(char[][] board) {
        SudoKu(board,0,0);
    }
    private boolean SudoKu(char[][] board,int i,int j){
        if(i==8 && j==9)return true;
        if(j==9){
            i++;j=0;
        }
        if(board[i][j]!='.'){
            if(SudoKu(board,i,j+1))return true;
        }else{
            int[] map=getValidNum(board,i,j);
            for(int k=1;k<10;k++){
                if(map[k]==0){
                    board[i][j]=(char)(k+'0');
                    if(SudoKu(board,i,j+1))return true;
                    board[i][j]='.';
                }
            }
        }
        return false;
    }
    private int[] getValidNum(char[][] board,int i,int j){
        int[] map=new int[10];
        for(int k=0;k<9;k++){
            if(board[i][k]!='.')map[board[i][k]-'0']=1;
            if(board[k][j]!='.')map[board[k][j]-'0']=1;
        }
        for(int k=3*(i/3);k<3*(i/3)+3;k++){
            for(int l=3*(j/3);l<3*(j/3)+3;l++){
                if(board[k][l]!='.')map[board[k][l]-'0']=1;
            }
        }
        return map;
    }
}

C语言源代码(12ms):

int* getValidNum(char** board,int i,int j){
    int k,l;
    int* map = (int*)malloc(sizeof(int)*10);
    memset(map,0,sizeof(int)*10);
    for(k=0;k<9;k++){
        if(board[i][k]!='.') map[board[i][k]-'0']=1;
    }
    for(k=0;k<9;k++){
        if(board[k][j]!='.') map[board[k][j]-'0']=1;
    }
    for(k=3*(i/3);k<3*(i/3)+3;k++){
        for(l=3*(j/3);l<3*(j/3)+3;l++){
            if(board[k][l]!='.') map[board[k][l]-'0']=1;
        }
    }
    return map;
}
bool SudoKu(char** board,int i,int j){
    int k;
    if(i==8 && j==9)return true;
    if(j==9){
        i++;
        j=0;
    }
    if(board[i][j]!='.'){
        if(SudoKu(board,i,j+1))return true;
    }else{
        int* map=getValidNum(board,i,j);
        for(k=1;k<10;k++){
            if(map[k]==0){
                board[i][j]=k+'0';
                if(SudoKu(board,i,j+1))return true;
                board[i][j]='.';
            }
        }
        free(map);
    }
    return false;
}
void solveSudoku(char** board, int boardRowSize, int boardColSize) {
    SudoKu(board,0,0);
}

C++源代码(24ms):

class Solution {
public:
    void solveSudoku(vector<vector<char>>& board) {
        SudoKu(board,0,0);
    }
private:
    bool SudoKu(vector<vector<char>>& board,int i,int j){
        if(i==8 && j==9)return true;
        if(j==9){
            i++;j=0;
        }
        if(board[i][j]!='.'){
            if(SudoKu(board,i,j+1))return true;
        }else{
            int* map=getValidNum(board,i,j);
            for(int k=1;k<10;k++){
                if(map[k]==0){
                    board[i][j]=k+'0';
                    if(SudoKu(board,i,j+1))return true;
                    board[i][j]='.';
                }
            }
        }
        return false;
    }
    int* getValidNum(vector<vector<char>>& board,int i,int j){
        int* map=(int*)malloc(sizeof(int)*10);
        memset(map,0,sizeof(int)*10);
        for(int k=0;k<9;k++){
            if(board[i][k]!='.')map[board[i][k]-'0']=1;
            if(board[k][j]!='.')map[board[k][j]-'0']=1;
        }
        for(int k=3*(i/3);k<3*(i/3)+3;k++){
            for(int l=3*(j/3);l<3*(j/3)+3;l++){
                if(board[k][l]!='.')map[board[k][l]-'0']=1;
            }
        }
        return map;
    }
};

Python源代码(636ms):

class Solution:
    # @param {character[][]} board
    # @return {void} Do not return anything, modify board in-place instead.
    def solveSudoku(self, board):
        self.SudoKu(board,0,0)
    def SudoKu(self,board,i,j):
        if i==8 and j==9:return True
        if j==9:i+=1;j=0
        if board[i][j]!='.':
            if self.SudoKu(board,i,j+1):return True
        else:
            map=self.getValidNum(board,i,j)
            for k in range(1,10):
                if map[k]==0:
                    board[i][j]=chr(k+ord('0'))
                    if self.SudoKu(board,i,j+1):return True
                    board[i][j]='.'
        return False
    def getValidNum(self,board,i,j):
        map=[0 for k in range(10)]
        for k in range(9):
            if board[i][k]!='.':map[ord(board[i][k])-ord('0')]=1
            if board[k][j]!='.':map[ord(board[k][j])-ord('0')]=1
        for k in range(3*(i/3),3*(i/3)+3):
            for l in range(3*(j/3),3*(j/3)+3):
                if board[k][l]!='.':map[ord(board[k][l])-ord('0')]=1
        return map
时间: 2024-11-05 14:41:55

LeetCode 37 Sudoku Solver (C,C++,Java,Python)的相关文章

Java [leetcode 37]Sudoku Solver

题目描述: Write a program to solve a Sudoku puzzle by filling the empty cells. Empty cells are indicated by the character '.'. You may assume that there will be only one unique solution. A sudoku puzzle... ...and its solution numbers marked in red. 解题思路:

leetcode 37 Sudoku Solver java

求数独,只要求做出一个答案就可以. 刚开始对题意理解错误,以为答案是唯一的, 所以做了很久并没有做出来,发现答案不唯一之后,使用回溯.(还是借鉴了一下别人) public class Solution { public void solveSudoku(char[][] board) { HashSet[] hashset = new HashSet[27]; for (int i = 0; i < 27; i++) hashset[i] = new HashSet<Character>

[LeetCode] 37. Sudoku Solver 求解数独

Write a program to solve a Sudoku puzzle by filling the empty cells. A sudoku solution must satisfy all of the following rules: Each of the digits 1-9 must occur exactly once in each row. Each of the digits 1-9 must occur exactly once in each column.

LeetCode 37 Sudoku Solver(求解数独)

题目链接: https://leetcode.com/problems/sudoku-solver/?tab=Description Problem : 解决数独问题,给出一个二维数组,将这个数独进行求解. 思路: 嵌套循环,三层循环体,每一行,每一列,填入从1到9的数字.判断填入之后是否合理 判断数独是否合理的函数 参考代码: package leetcode_50; /*** * * @author pengfei_zheng * 求解数独问题 */ public class Solutio

[leetcode 37]sudoku solver

1 题目: 根据给出的数独,全部填出来 2 思路: 为了做出来,我自己人工做了一遍题目给的数独.思路是看要填的数字横.竖.子是否已经有1-9的数字,有就剔除一个,最后剩下一个的话,就填上.一遍一遍的循环,直到填完为止. 后来发现,这个思路只能解决部分数独.还有部分数独是需要回溯的,比如,这个位置只能填3或5,那么就需要先填上3,看看能否继续填下去,不能的话,再回过来填5. 想了半天,想不出来,把别人的backtracking看懂了,写出来了.. 3 代码: 自己的: Hashtable<Inte

【leetcode】 Sudoku Solver

问题: Write a program to solve a Sudoku puzzle by filling the empty cells. Empty cells are indicated by the character '.'. You may assume that there will be only one unique solution. A sudoku puzzle... ...and its solution numbers marked in red. 说明: 数独有

37. Sudoku Solver(js)

37. Sudoku Solver Write a program to solve a Sudoku puzzle by filling the empty cells. A sudoku solution must satisfy all of the following rules: Each of the digits 1-9 must occur exactly once in each row. Each of the digits 1-9 must occur exactly on

[Leetcode][Python]37: Sudoku Solver

# -*- coding: utf8 -*-'''__author__ = '[email protected]' 37: Sudoku Solverhttps://oj.leetcode.com/problems/sudoku-solver/ Write a program to solve a Sudoku puzzle by filling the empty cells.Empty cells are indicated by the character '.'.You may assu

[LeetCode][JavaScript]Sudoku Solver

Sudoku Solver Write a program to solve a Sudoku puzzle by filling the empty cells. Empty cells are indicated by the character '.'. You may assume that there will be only one unique solution. A sudoku puzzle... ...and its solution numbers marked in re